#!"D:\cacti_srv\perl-5-8-7.813\bin\perl.exe"
use strict;
use CGI;
use File::Basename;
use lib dirname($0);
use lib '.';
use Socket;
use LWP::Simple;
use LWP::UserAgent;
use XML::Parser;
use XML::SimpleObject;
use constant TRUE => 1;
use constant FALSE => 0;
use perlchartdir;

my $query = CGI->new();

#print "Content-type: text/html\n\n";
print "Content-type: image/png\n\n";

my $deviceIP = $query->param('device'); #'53.29.55.23';
my $stime= $query->param('stime').'000'; #1202823120000;
my $etime= $query->param('etime').'000'; #1202829840000;;
my $url= $query->param('url'); 
my $userid= $query->param('userid'); 
my $password= $query->param('password');
my $interface= $query->param('interface') - 1;
my $direction= $query->param('direction'); 
my $type = $query->param('type') || 'chart'; 

$deviceIP = inet_ntoa(inet_aton($deviceIP));
my $startReport = FALSE;
my $headerDone = FALSE;
my $startData = FALSE;
my $endData = FALSE;
my $firstLine = FALSE;
my $secondLine = FALSE;
my $counter = 0;
my $width = 889;
my $height = 268;
my $seconds = $query->param('etime') -  $query->param('stime'); # seconds * minutes * hours

my @labelArr = ();
my @timestamps = ();


# $nmid_nf_url.'report.jsp?templid=0000&output=table&stime='.$stime.'&etime='.$etime.'
#&device='.$host_ip.'&format=xml&j_username='.$nmid_nf_userid.'&j_password='.$nmid_nf_password."
#&interface=".$nftracker_interface."&direction=out&resolve=none&start=1&nrecords=20&order=2_Traffic";

my $nf_url = '';

if ($type eq 'toptalkers')
{
$nf_url = $url.'report.jsp?templid=0000&output=chart&device='.$deviceIP.
            '&format=xml&j_username='.$userid.
            '&j_password='.$password.
            '&stime='.$stime.
            '&etime='.$etime.
            '&direction='.$direction.'&interface='.$interface.
            '&resolve=none&start=1&nrecords=20&order=2_Traffic';    
}
else
{
$nf_url = $url.'report.jsp?templid=_topapps&output=chart&device='.$deviceIP.
            '&format=xml&j_username='.$userid.
            '&j_password='.$password.
            '&stime='.$stime.
            '&etime='.$etime.
            '&'.$direction.'if='.$deviceIP.'/'.$interface;
}

#print $nf_url."<br>";
my $user_agent = LWP::UserAgent->new;

my $request = HTTP::Request->new('GET',$nf_url);
my $responseStr = $user_agent->request($request);
foreach my $header ( $responseStr->header_field_names() )
{
 $responseStr->remove_header($header);
}
$responseStr = $responseStr->as_string;
$responseStr =~ s/HTTP\/1.1 200 OK\n\n//ig;

my $parser = XML::Parser->new( ErrorContext => 2, Style => "Tree" );

my $tree = XML::SimpleObject->new( $parser->parsestring($responseStr) );

my %nfTimeData = undef;
my %nfValueData = undef;
my %apps = undef;

my $timeDone = FALSE;
foreach my $chart ($tree->child('r:report')->child('chart') )
{
    if ( $chart->attribute('title') eq "Traffic Rate")
    {
        foreach my $dataset ( $chart->child('datasets')->child('dataset')  ) {
            my $appName = '';        
            if ( defined( $dataset->child('description')->child('port') ) )
            {
                $appName = $dataset->child('description')->child('port')->child('protocol')->attribute('name');
                $appName .= '(';
                $appName .= $dataset->child('description')->child('port')->attribute('number');
                $appName .= ')';
            }
            elsif ( defined( $dataset->child('description')->child('application') ) )
            {
                $appName = $dataset->child('description')->child('application')->attribute('name');
            }
            elsif ( defined ( $dataset->child('description')->child('address') ) )
            {
                $appName = $dataset->child('description')->child('address')->attribute('address');
            }
            else
            {
                $appName = 'Others';
            }
            $apps{$appName} = 'Ok';
			foreach my $sample ( $dataset->child('samples')->child('sample') )
			{
                my $timeValue = $sample->child('start-time')->attribute('utc');
                my $etimeValue = $sample->child('end-time')->attribute('utc');
                $seconds = $etimeValue - $timeValue;
                $timeValue =~ s/000$//ig;
				$nfValueData{$appName} .= $timeValue . '='. ( ( ( ( $sample->child('value')->value ) / 1000 ) / $seconds  ) * 8).';';
			}
        }
    }
}

my %allTimes = undef;

foreach my $key ( keys %nfValueData )
{
    my @data = split/;/,$nfValueData{$key};
    foreach my $dataLine ( @data )
    {
        my @timeData = split/=/,$dataLine;
        $allTimes{$timeData[0]} = '';
    }
}

foreach my $key ( keys %allTimes )
{
    next if ($key eq '');
    push @timestamps, $key;
}
@timestamps = sort(@timestamps);

my @timestamps_2 = undef;

for (my $count = 0;$count < $#timestamps -1 ; $count++ )
{
    $timestamps_2[$count] = $timestamps[$count];
    $timestamps[$count] = perlchartdir::chartTime2($timestamps[$count]);
}
my $times = \@timestamps;

#XYChart object of size 500 x 300 pixels, with a pale yellow (0xffffc0)
# background, a black border, and 1 pixel 3D border effect
my $c = new XYChart($width, $height, 0xe9e9e9, 0x000000, 1);

#Set directory for loading images to current script directory
#Need when running under Microsoft IIS
$c->setSearchPath(dirname($0));

# Set the plotarea at (55, 50) and of size 420 x 205 pixels, with white background.
# Turn on both horizontal and vertical grid lines with light grey color (0xc0c0c0)
$c->setPlotArea(60, 10, $width * 0.9, 180, 0xffffff)->setGridColor(0xc0c0c0, 0xc0c0c0);

# Add a title to the y axis
if ($type eq 'toptalkers')
{
    $c->yAxis()->setTitle("Traffic ( Mbps )");
}
else
{
    $c->yAxis()->setTitle(uc($direction) . " Traffic ( Mbps )");
}


# Set the labels on the x axis.
$c->xAxis()->setLabels2($times, "{value|hh:nn}");

# Display 1 out of 2 labels on the x-axis. Show minor ticks for remaining labels.
$c->xAxis()->setLabelStep(20,2,20);
$c->yAxis()->setLabelStep(1,0.5);

# Add an stack area layer with three data sets
my $layer = $c->addBarLayer2($perlchartdir::Stack);
$layer->setBarGap($perlchartdir::TouchBar);
my $colorCounter = -1;
my @colors = (0x4040ff,0x00cf00,0xff3932,0xff00ff,0xeacc00,0xc4fd3d,0xafeced,0x8e85f3,
              0x7ee600,0x0000ff,0xff7d00,0xcccccc,0x6557d0,0x00aaaa,0xf5f800,0xcaf100,
              0xccbb00,0x11f121,0x337479,0x335577,0x772277,0x777722,0x335566,0x666633);



               
foreach my $key ( keys %nfValueData )
{
    $colorCounter++;
    my @chartData = ();
    my @data = split/;/,$nfValueData{$key};
    foreach my $time ( @timestamps_2 )
    {
        my $timeOk = FALSE;
        foreach my $dataLine ( @data )
        {
            my @valueData = split/=/,$dataLine;
            if ( $valueData[0] eq $time )
            {
                push @chartData, $valueData[1];
                $timeOk = TRUE;
            }
        }
        if ($timeOk == FALSE)
        {
            push @chartData, 0;
        }
    }
    $layer->addDataSet(\@chartData,$colors[$colorCounter] , $key);
}
# Add a legend box at (50, 185) (below of plot area) using horizontal layout. Use 8
# pts Arial font with Transparent background.
$c->addLegend(50, 200, 0, "", 8)->setBackground($perlchartdir::Transparent);

$layer->setLineWidth(0);
#$layer->setBorderColor($perlchartdir::Transparent);

# Set the axes width to 2 pixels
$c->xAxis()->setWidth(2);
$c->yAxis()->setWidth(2);

# output the chart
binmode(STDOUT);
print $c->makeChart2($perlchartdir::PNG);
