<?php
/*******************************************************************************

    Author ......... Thomas Urban
    Contact ........ nmid@urban-software.de
    Home Site ...... http://www.urban-software.de
    Program ........ Network Management Inventory Database for Cacti
    Version ........ 0.1
    Purpose ........ Exporting Inventory Information to other
					 network manangement tools.
					 
	NM Tools ....... Smokeping
					 NetFlow Tracker ( Fluke Networks )
*******************************************************************************/

function plugin_init_nmidNFTracker() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['nmidNFTracker'] = 'nmidNFTracker_config_arrays';
	$plugin_hooks['config_settings']['nmidNFTracker'] = 'nmidNFTracker_config_settings';
	$plugin_hooks['console_after']['nmidNFTracker'] = 'nmidNFTracker_console_after';
    $plugin_hooks['tree_after']['nmidNFTracker'] = 'nmidNFTracker_tree_after';
	$plugin_hooks['nmid_plugin_value']['nmidNFTracker'] = 'nmidNFTracker_value';
	$plugin_hooks['nmid_plugin_header']['nmidNFTracker'] = 'nmidNFTracker_header';
	$plugin_hooks['nmid_plugin_save']['nmidNFTracker'] = 'nmidNFTracker_save';
}

function nmidNFTracker_save ( $param )
{
    $key = $param['key'];
    $value = $param['value'];
    
    if ( preg_match("/^nftracker_interface/",$key) > 0 )
    {
            preg_match("/^(\d+)_(\d+)$/",$value,$hit);
            $host_id = $hit[1];
            $snmpindex_id = $hit[2];
            db_execute("UPDATE host SET nwmgmt_nftracker_index=\"$snmpindex_id\" WHERE id=".$host_id);
    }            
    elseif ( preg_match("/^nftracker_device/",$key) > 0 ) 
    {
        if ( preg_match("/^add/",$value["0"]) > 0 )
        {
            preg_match("/_(\d+)$/",$key,$hit);
            $host_id = $hit[1];
            $current_nwmgmt_settings = db_fetch_cell("select nwmgmt_settings from host where id=$host_id");
            if ( preg_match("/^s\d\d\d1/",$current_nwmgmt_settings) == 0)
            {
                /* NFTracker not set, yet */
                $current_nwmgmt_settings = preg_replace("/^(s\d\d\d)\d/","\${1}1",$current_nwmgmt_settings);
                db_execute("UPDATE host SET nwmgmt_settings = \"$current_nwmgmt_settings\" WHERE id=$host_id");
            }
            else
            {
                //print "NF Tracker Host: $host_id is aready set: $current_nwmgmt_settings<br>\n";
            }
        }
        else
        {
            preg_match("/_(\d+)$/",$key,$hit);
            $host_id = $hit[1];
            $current_nwmgmt_settings = db_fetch_cell("select nwmgmt_settings from host where id=$host_id");
            if ( preg_match("/^s\d\d\d0/",$current_nwmgmt_settings) == 0)
            {
                /* NFTracker set, yet */
                $current_nwmgmt_settings = preg_replace("/^(s\d\d\d)\d/","\${1}0",$current_nwmgmt_settings);
                db_execute("UPDATE host SET nwmgmt_settings = \"$current_nwmgmt_settings\" WHERE id=$host_id");
            }
            else
            {
                //print "NF Tracker Host: $host_id is aready removed: $current_nwmgmt_settings<br>\n";
            }
        }
    }
    return ( $param );
}

function nmidNFTracker_header ( $display_text )
{
    $temp = array(
		"nftracker_add" => array("Reports to NF Tracker<br>Yes/No", "ASC"),
		"nftracker_interface" => array("Select Netflow Interface", "ASC"),
	);

    $display_text = array_merge($display_text, $temp);
    return $display_text;
}

function nmidNFTracker_value ( $hostid )
{
	$current_nwmgmt_settings = db_fetch_cell("select nwmgmt_settings from host where id=".$hostid);
	$snmpIndexes = db_fetch_assoc("select DISTINCT snmp_index from host_snmp_cache where host_id=".$hostid);
	$nftracker_interface = db_fetch_cell("select nwmgmt_nftracker_index from host where id=".$hostid);

	$nftracker_add_selected = '';
	$nftracker_del_selected = '';
	
	/* NF Tracker Addon */
	if (preg_match("/^s\d\d\d1/",$current_nwmgmt_settings) > 0)
	{
		$nftracker_add_selected = 'CHECKED';
	}
	else
	{
		$nftracker_del_selected = 'CHECKED';  
	}

	print "<td align=left>".
	"<input type=radio $nftracker_add_selected name=\"nftracker_device_".$hostid."[]\"value=add>".
	" / <input type=radio $nftracker_del_selected name=\"nftracker_device_".$hostid."[]\"value=delete>".
	"</td>";				
	print "<td align=left>";
	print "<select name=nftracker_interface>\n";
	foreach ($snmpIndexes as $snmpIndex)
	{
		$fieldValues = db_fetch_assoc("SELECT DISTINCT field_name,field_value from host_snmp_cache ".
									  "WHERE host_id = ".$hostid. " ".
									  "AND snmp_index = ".$snmpIndex['snmp_index']. " ".
									  "AND ( field_name=\"ifName\" OR field_name=\"ifDescr\" or field_name=\"ifOperStatus\") ".
									  "ORDER BY snmp_index");

		$nfif_selected = '';
		if ($snmpIndex['snmp_index'] == $nftracker_interface)
		{
			$nfif_selected = 'SELECTED';
		}
		print "<option $nfif_selected value=".$hostid."_".$snmpIndex['snmp_index'].">";
		$ifName_printed = 0;
		foreach ($fieldValues as $fvalue)
		{
			if ($fvalue['field_name'] != 'ifOperStatus')
			{
				if ( ( $fvalue['field_name'] == 'ifName') && ( $fvalue['field_value'] != '' ) )
				{
					if ( $ifName_printed == 0 )
					{
						print $fvalue['field_value'] . ' ';
					}
					$ifName_printed = 1;
				}
				elseif ( ( $fvalue['field_name'] == 'ifDescr') && ( $fvalue['field_value'] != '' ) )
				{
					if ( $ifName_printed == 0 )
					{
						print $fvalue['field_value'] . ' ';
						$ifName_printed = 1;
					}
					
				}
				else
				{
					print $fvalue['field_value'] . ' ';
				}
			}
		}
		print "\n";
		print "</option>\n";

	}
	print "</select>\n";
	print "</td>";
	return $hostid;
}


function nmidNFTracker_tree_after ($param)
{
	global $config, $database_default;
    preg_match("/^(.+),(\d+)$/",$param,$hit);
	include_once($config["library_path"] . "/adodb/adodb.inc.php");
	include_once($config["library_path"] . "/database.php");

    if ( isset ( $hit[1] ) )
	{    
        $host_name = $hit[1];
        $host_leaf_id = $hit[2];
    
		$host_id = db_fetch_cell("select host_id from graph_tree_items where id=$host_leaf_id");
		$host_ip = db_fetch_cell("select hostname from host where id=".$host_id);
		$current_nwmgmt_settings = db_fetch_cell("select nwmgmt_settings from host where id=".$host_id);
		$nftracker_interface = db_fetch_cell("select nwmgmt_nftracker_index from host where id=".$host_id);
		
		/* Retrieve Config Settings */
		$nmid_nf_url = read_config_option("nmid_nfurl");
		$nmid_nf_userid = read_config_option("nmid_nfuser");
		$nmid_nf_password = read_config_option("nmid_nfpwd");
		$nmid_nf_topn = read_config_option("nmid_nftopn");

		/* Display NF Tracker NetFlow Graph if configured for this device */
		if ( preg_match("/s^\d\d\d1/",$current_nwmgmt_settings ) > 0 )
		{
			print "<tr bgcolor='#a9b7cb'>\n";
			print "	<td colspan='3' class='textHeaderDark'><strong>Graph Template:</strong> NetFlow - Top Applications (external)</td>\n";
			print "</tr>";
			print "<td align='center'>\n";
			print "	<table width='1' cellpadding='0'>\n";
			print "		<tr>\n";
			print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
			print "				<img src=\"".$config['url_path']."cgi-bin/getNetFlowHistory.pl?stime=".get_current_graph_start()."&etime=".get_current_graph_end()."&device=".$host_ip."&url=".$nmid_nf_url."&userid=".$nmid_nf_userid."&password=".$nmid_nf_password."&interface=".$nftracker_interface."&direction=in\">\n";
			print "			</td>\n";
			print "			<td valign='top' style='padding: 3px;' class='noprint'><a target='_blank' href='".$nmid_nf_url.'report.jsp?templid=_ifs&output=table&length=21600000&format=html&splash=false&reload=60&start=1&nrecords=-1&order=1_Device+Name&drilldown_filter=device%3D'.$host_ip."'><img src='".$config['url_path']."images/graph_zoom.gif' border='0' alt='Go to NetFlow Tracker' title='Go to NetFlow Tracker' style='padding: 3px;'></a></td>";
			print "		</tr>\n";
			print "		<tr>\n";
			print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
			print "				<img src=\"".$config['url_path']."cgi-bin/getNetFlowHistory.pl?stime=".get_current_graph_start()."&etime=".get_current_graph_end()."&device=".$host_ip."&url=".$nmid_nf_url."&userid=".$nmid_nf_userid."&password=".$nmid_nf_password."&interface=".$nftracker_interface."&direction=out\">\n";
			print "			</td>\n";
			print "			<td valign='top' style='padding: 3px;' class='noprint'><a target='_blank' href='".$nmid_nf_url.'report.jsp?templid=_ifs&output=table&length=21600000&format=html&splash=false&reload=60&start=1&nrecords=-1&order=1_Device+Name&drilldown_filter=device%3D'.$host_ip."'><img src='".$config['url_path']."images/graph_zoom.gif' border='0' alt='Go to NetFlow Tracker' title='Go to NetFlow Tracker' style='padding: 3px;'></a></td>";
			print "		</tr>\n";
			print "</table>\n";
			print "</td></tr>";

			if ((db_fetch_assoc("select user_auth_realm.realm_id
				from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
				and user_auth_realm.realm_id='1192'")) )
			{

				$etime = get_current_graph_end().'000';
				$stime = get_current_graph_start() . '000';
	
				$url = $nmid_nf_url.'report.jsp?templid=0000&output=table&stime='.$stime.'&etime='.$etime.'&device='.$host_ip.'&format=xml&j_username='.$nmid_nf_userid.'&j_password='.$nmid_nf_password."&interface=".$nftracker_interface."&direction=in&resolve=none&start=1&nrecords=".$nmid_nf_topn."&order=2_Traffic";
				
				$response = GetCurlPage($url);
				
				$xml = new SimpleXMLElement($response);
	
				foreach ( $xml->table as $table )
				{
					print "<tr bgcolor='#a9b7cb'>\n";
					print "	<td colspan='3' class='textHeaderDark'><strong>Graph Template:</strong> NetFlow - Top Source Addresses (external)</td>\n";
					print "</tr>";
					print "<td align='center'>\n";
					print "	<table width='1' cellpadding='0'>\n";
					print "		<tr>\n";
					print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
					print "				<img src=\"".$config['url_path']."cgi-bin/getNetFlowHistory.pl?stime=".get_current_graph_start()."&etime=".get_current_graph_end()."&device=".$host_ip."&url=".$nmid_nf_url."&userid=".$nmid_nf_userid."&password=".$nmid_nf_password."&interface=".$nftracker_interface."&direction=in&type=toptalkers\">\n";
					print "			</td>\n";
					print "			<td valign='top' style='padding: 3px;' class='noprint'><a target='_blank' href='".$nmid_nf_url.'report.jsp?templid=_ifs&output=table&length=21600000&format=html&splash=false&reload=60&start=1&nrecords=-1&order=1_Device+Name&drilldown_filter=device%3D'.$host_ip."'><img src='/images/graph_zoom.gif' border='0' alt='Go to NetFlow Tracker' title='Go to NetFlow Tracker' style='padding: 3px;'></a></td>";
					print "		</tr>\n";
					print "		<tr>\n";
					print "			<td valign='top' style='padding: 3px;' class='noprint'>\n";
					print "<table width=99%>";
					print "<tr>";
					print "<td align=center colspan=5><b>Top ".$nmid_nf_topn."</b></td>\n";
					print "</tr>";
					print "<tr>";
					print "	<th align=left>".$xml->table[0]->{'columns'}->{'address-column'}['heading']."</th>";
					print "	<th align=right>".$xml->table[0]->{'columns'}->{'octet-column'}['heading']."</th>";
					print "	<th align=right>".$xml->table[0]->{'columns'}->{'octet-percentage-column'}['heading']."</th>";
					print "	<th align=right>".$xml->table[0]->{'columns'}->{'large-value-column'}['heading']."</th>";
					print "	<th align=right>".$xml->table[0]->{'columns'}->{'percentage-column'}['heading']."</th>";
					print "</tr>";
					print "<tr>";
					print "<td colspan=5><hr></td>\n";
					print "</tr>";
					foreach ($xml->table->results->result as $result) {
						print "<tr>";
						print "<td align=left>".$result->{'address'}['address']."</td>";
						print "<td align=right>".$result->{'value'}[0]."</td>";
						print "<td align=right>".$result->{'percentage'}[0]."</td>";
						print "<td align=right>".$result->{'value'}[1]."</td>";
						print "<td align=right>".$result->{'percentage'}[1]."</td>";
						print "</tr>";
					}
					print "</table>";
					print "			</td>";
					print "			<td valign='top' style='padding: 3px;' class='noprint'><a target='_blank' href='".$nmid_nf_url.'report.jsp?templid=_ifs&output=table&length=21600000&format=html&splash=false&reload=60&start=1&nrecords=-1&order=1_Device+Name&drilldown_filter=device%3D'.$host_ip."'><img src='/images/graph_zoom.gif' border='0' alt='Go to NetFlow Tracker' title='Go to NetFlow Tracker' style='padding: 3px;'></a></td>";
					print "		</tr>\n";
					print "</table>\n";
					print "</td></tr>";
				}
			}
		}
	}
	return $param;
}

function nmidNFTracker_console_after () {
	global $config, $plugins;
	nmidNFTracker_setup_table();
}
	
function nmidNFTracker_config_settings () {
	global $tabs, $settings;
	$tabs["nmid"] = "NMID";

	$temp = array(
		"nmid_nfheader" => array(
			"friendly_name" => "NMID - NF Tracker",
			"method" => "spacer",
			),
		"nmid_nfurl" => array(
			"friendly_name" => "NF Tracker URL",
			"description" => "This is the full URL used to connect to the NF Tracker server.  (ex: http://1.2.3.4:8000/).",
			"method" => "textbox",
			"max_length" => 255,
			),
		"nmid_nfuser" => array(
			"friendly_name" => "NF Tracker UserID",
			"description" => "UserID used to connect to NF Tracker.",
			"method" => "textbox",
			"max_length" => 20,
			),
		"nmid_nfpwd" => array(
			"friendly_name" => "NF Tracker Password",
			"description" => "Password used to connect to NF Tracker.",
			"method" => "textbox_password",
			"max_length" => 20,
			),
		"nmid_nftopn" => array(
			"friendly_name" => "NF Tracker TopN Count",
			"description" => "Number of TopN addresses to show.",
			"method" => "textbox",
			"max_length" => 10,
			),
	);

	if (isset($settings["nmid"]))
		$settings["nmid"] = array_merge($settings["nmid"], $temp);
	else
		$settings["nmid"] = $temp;
}

function nmidNFTracker_version () {
	return array( 'name' 	=> 'nmid_nftracker',
			'version' 	=> '0.3.9a',
			'longname'	=> 'NMID NFTracker Plugin',
			'author'	=> 'Thomas Urban',
			'homepage'	=> 'http://www.urban-software.de',
			'email'	=> 'nmid@urban-software.de',
			'url'		=> 'http://urban-software.de/nmid/nftracker/versions.php'
			);
}

function nmidNFTracker_config_arrays () {
	global $user_auth_realms;
	$user_auth_realms[1192]='View NMID TopN Graphs';
}


function nmidNFTracker_setup_table () {
	global $config, $database_default;

	include_once($config["library_path"] . "/adodb/adodb.inc.php");
	include_once($config["library_path"] . "/database.php");
	
    $entires = db_fetch_assoc("describe host");
    $entry_exists = 0;
    foreach ($entires as $entry)
    {
        if ($entry["Field"] == "nwmgmt_nftracker_index")
        {
                $entry_exists = 1;
        }
    }
    if ($entry_exists == 0)
    {
		// required for NF Tracker
        db_execute("alter table host add nwmgmt_nftracker_index varchar(50)");
	}
	
}

?>
